<?php
/**
 * The loop template file.
 *
 * Included on pages like index.php, archive.php and search.php to display a loop of posts
 * Learn more: https://codex.wordpress.org/The_Loop
 *
 * @package olars
 */

do_action('olars_loop_before');

$blog_style = olars_get_theme_option('blog_style');

if ($blog_style && $blog_style !== 'standard') {
    echo '<div class="blog-style-grid">';
}
while ( have_posts() ) :
    the_post();

    /**
     * Include the Post-Format-specific template for the content.
     * If you want to override this in a child theme, then include a file
     * called content-___.php (where ___ is the Post Format name) and that will be used instead.
     */
    get_template_part('content', get_post_format());

endwhile;

if ($blog_style && $blog_style !== 'standard') {
    echo '</div>';
}

/**
 * Functions hooked in to olars_loop_after action
 *
 * @see olars_paging_nav - 10
 */
do_action('olars_loop_after');
